import { UnknownKV } from './generics';
export declare type Directives = Record<string, (props: DirectiveProps) => void>;
export declare type Watchers = Record<string, () => void>;
export declare type Refs = Record<string, HTMLElement>;
export declare type State = UnknownKV;
export declare type DirectiveKV = Record<string, DirectiveData>;
export interface DirectiveData {
    compute: (state: UnknownKV, event?: Event) => any;
    value: string;
    deps: string[];
}
export interface DirectiveProps {
    el: HTMLElement;
    parts: string[];
    data: DirectiveData;
    state: State;
    node?: ASTNode;
}
export interface ASTNode {
    directives: DirectiveKV;
    deps: string[];
    el: HTMLElement;
    type: ASTNodeType;
}
export declare enum ASTNodeType {
    NULL = -1,
    STATIC = 0,
    DYNAMIC = 1
}
